import es, popuplib, random, gamethread, math
from dnds import *
info = es.AddonInfo()
info.name = 'D&DSource Mod - PVKII'
info.version = '0.1.2 Python'
info.url = 'http://addons.eventscripts.com/addons/view/dnds'
info.basename = 'pvkiidnds'
info.author = 'J3ff Hoogland'
#Begin Events
#Local Events
def est_client_keypress(ev):
    userid = int(ev['userid'])
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if ev['keyname'] == 'duck' or ev['keyname'] == 'speed':
            if ev['status'] == '1':
                StealthOn(userid)
            else:
                StealthOff(userid)
        elif ev['key'] == 'attack2':
            if ev['status'] == '1' and dnds.getPlayer(userid)['playerlib'].get('weapon') in Meele_Weapons:
                dnds.getPlayer(userid)['Player'].key['blocking'] = 1
            else:
                dnds.getPlayer(userid)['Player'].key['blocking'] = 0
def round_end(ev):
    if int(es.ServerVar('dnds_RoundWonXp')):
        for id in es.getUseridList():
            if es.getplayerteam(id) == int(ev['winner']):
                dnds.getPlayer(id)['Character'].GiveXp(int(es.ServerVar('dnds_RoundWonXp')), dnds.text('round_end 1',{},dnds.getPlayer(id)['playerlib'].get('lang')))
def player_spawn(ev):
    userid = int(ev['userid'])
    Character = dnds.getPlayer(userid)['Character']
    Playerlib = dnds.getPlayer(userid)['playerlib']
    Player = dnds.getPlayer(userid)['Player']
    for x in default_keys:
        Player.key[x] = 0
    for x in ['long jump', 'gravity']:
        Player.key[x] = 1.0
    Classes = Character.key['classes']
    if len(Character.key['classes']):
        Class = Character.key['classes'].keys()[0]
    else:
        Class = None
    if Class:
        if dnds.statCheck(userid):
            Playerlib.set('speed', dnds.Classes[Class]['speed'])
            Player.key['healing surges'] = dnds.Classes[Class]['healing surges']+dnds.statMod(userid, 'Constitution')
            if 'Durable' in Character.key['feats']:
                Player.key['healing surges'] += 2
            if 'Fase Runner' in Character.key['feats']:
                Playerlib.set('speed', Playerlib.get('speed')+.1)
            if 'Light Step' in Character.key['feats']:
                Playerlib.set('speed', Playerlib.get('speed')+.1)
            if 'Long Jumper' in Character.key['feats']:
                Player.key['long jump'] += .15
            es.setplayerprop(userid, 'CPVK2Player.m_iMaxHealth', dnds.Classes[Class]['health']+(Character.key['abilities']['Constitution']*10))
            if 'Toughness' in Character.key['feats']:
                es.setplayerprop(userid, 'CPVK2Player.m_iMaxHealth', int(es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth'))+30)
            dnds.report('PVKII - %s Max Health %s'%(es.getplayername(userid), es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth')))
            gamethread.delayed(.25, es.setplayerprop, (userid, 'CBasePlayer.m_iHealth', es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth')))
            es.setplayerprop(userid, 'CPVK2Player.m_iMaxArmor', dnds.Classes[Class]['armor'])
            gamethread.delayed(.25, es.setplayerprop, (userid, 'CPVK2Player.m_ArmorValue', es.getplayerprop(userid,'CPVK2Player.m_iMaxArmor')))
            dnds.report('PVKII - %s Max Armor %s'%(es.getplayername(userid),dnds.Classes[Class]['armor']))
            Playerlib.set('model', dnds.Classes[Class]['model'])
            es.server.queuecmd('est_stripplayer %s'%userid)
            for x in dnds.Classes[Class]['weapons']:
                es.server.queuecmd('es_xdelayed .5 es_xgive %s %s'%(userid, x))
            if 'Warlord' in Classes:
                if Classes['Warlord']['level'] >= 4:
                    dnds.getPlayer(userid)['Player'].key['wl list'] = []
                    defenseAura(userid, 'wl')
                if Classes['Warlord']['level'] >= 7:
                    dnds.getPlayer(userid)['Player'].key['wl hlist'] = []
                    holdAura(userid, 'wl')
            if 'Rogue' in Classes:
                if Classes['Rogue']['level'] >= 7:
                    Player.key['long jump'] += .15
            if 'Paladin' in Classes:
                if Classes['Paladin']['level'] >= 6:
                    dnds.getPlayer(userid)['Player'].key['pa list'] = []
                    defenseAura(userid, 'pa')
            if 'Fighter' in Classes:
                if Classes['Fighter']['level'] >= 10:
                    BoundlessLoop(userid)
            if 'Ranger' in Classes:
                if Classes['Ranger']['level'] >= 10:
                    dnds.getPlayer(userid)['playerlib'].set('speed', int(dnds.getPlayer(userid)['playerlib'].get('speed'))+(.05*dnds.statMod(userid, 'Wisdom')))
            if Class == 'Ranger':
                if Character.key['weapon type'] == 'two weapon':
                    es.server.queuecmd('es_xdelayed .5 es_xgive %s weapon_axesword'%userid)
                    es.server.queuecmd('es_xdelayed .5 es_xgive %s weapon_throwaxe'%userid)
                elif Character.key['weapon type'] == 'archer':
                    es.server.queuecmd('es_xdelayed .5 es_xgive %s weapon_longbow'%userid)
            for x in dnds.Classes[Class]['ammo']:
                gamethread.delayed(.25, es.setplayerprop, (userid, 'CBasePlayer.localdata.m_iAmmo.%s'%x, dnds.Classes[Class]['ammo'][x]))
def player_damage(ev):
    userid = int(ev['userid'])
    attacker = int(ev['attacker'])
    damage = int(ev['dmg_health'])
    PlayerHurt(userid, attacker, damage, ev['weapon'], dnds.getPlayer(userid)['Character'].key['classes'].keys(), dnds.getPlayer(userid)['Character'])
    if attacker:
        PlayerHit(attacker, userid, damage, ev['weapon'], dnds.getPlayer(attacker)['Character'].key['classes'].keys(), dnds.getPlayer(attacker)['Character'])
def player_death(ev):
    userid = int(ev['userid'])
    Character = dnds.getPlayer(userid)['Character']
    if len(Character.key['classes']):
        Class = Character.key['classes'].keys()[0]
    else:
        Class = None
    if Class:
        if 'Warlord' in Character.key['classes'].keys():
            if Character.key['classes'].keys()['Warlord']['level'] >= 4:
                for id in dnds.getPlayer(userid)['Player'].key['wl list']:
                    dnds.getPlayer(id)['Player'].key['warlord aura'] = 0
#End Local Events
#Global Events
#End Global Events
#End Events
#Commands Methods
#Handels the count down for the wizard's spell cool downs
def spellCoolDown(userid, duration):
    if duration >= .5:
        duration -= .5
        dnds.getPlayer(userid)['Player'].key['spell cool down'] = duration
        dnds.getPlayer(userid)['Player'].Delayed(.5, spellCoolDown, (userid, duration))
    else:
        dnds.getPlayer(userid)['Player'].key['spell cool down'] = 0
#Warlord's Stand the Fallen power
def standcmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if 'Warlord' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Warlord']['level']
            if level >= 10:
                if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
                    spellCoolDown(userid, 12)
                    flist, olist = dnds.getPlayer(userid)['Player'].NearList(60)
                    for id in flist:
                        if Bloodied(id):
                            HealingSurge(id)
                            dnds.Beam(userid, id, 1, 0, 0, 0)
                else:
                    es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'using your Stand the Fallen'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('LowLevel',{'level':10,'power':'Stand the Fallen'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Warlord','power':'Stand the Fallen'},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Warlords crescendo power
def crescendocmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if 'Warlord' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Warlord']['level']
            if level >= 6:
                if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
                    es.ServerVar('_dnds_temp').set(0)
                    es.server.queuecmd('est_getviewplayer %s _dnds_temp'%userid)
                    gamethread.delayed(.1, crescendoRun, (userid))
                else:
                    es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'using your Crescendo of Violence'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('LowLevel',{'level':6,'power':'Crescendo of Violence'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Warlord','power':'Crescendo of Violence'},dnds.getPlayer(userid)['playerlib'].get('lang')))
def crescendoRun(userid):
    target = int(es.ServerVar('_dnds_temp'))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 300:
            TempHealth(userid, 10+(dnds.statMod(target, 'Charisma')*5), 10)
            spellCoolDown(userid, 8)
        else:
            es.tell(userid, '#multi', dnds.text('toofar',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Warlocks Stride Power
def stridecmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if 'Warlock' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Warlock']['level']
            if level >= 10:
                if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
                    es.ServerVar('_dnds_temp').set(0)
                    es.server.queuecmd('est_getviewplayer %s _dnds_temp'%userid)
                    gamethread.delayed(.1, strideRun, (userid))
                else:
                    es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'using your Otherwind Stride'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('LowLevel',{'level':10,'power':'Otherwind Stride'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Warlock','power':'Otherwind Stride'},dnds.getPlayer(userid)['playerlib'].get('lang')))
def strideRun(userid):
    target = int(es.ServerVar('_dnds_temp'))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 450:
            spellCoolDown(userid, 13)
            dnds.Beam3(userid, target, 1, 0, 0, 0)
            dnds.getPlayer(target)['Player'].Freeze(3)
            es.server.queuecmd('est_effect 7 #a 0 sprites/smoke.vmt %s %s %s 100 20'%(x1,y1,z1)) 
            es.server.queuecmd('es_xsetpos %s %s %s %s'%(userid, (x1+x2)/2, (y1+y2)/2, (z1+z2)/2))
        else:
            es.tell(userid, '#multi', dnds.text('toofar',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Warlocks Fire Bolt power
def boltcmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if 'Warlock' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Warlock']['level']
            if level >= 9:
                if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
                    es.ServerVar('_dnds_temp').set(0)
                    es.server.queuecmd('est_getviewplayer %s _dnds_temp'%userid)
                    gamethread.delayed(.1, boltRun, (userid))
                else:
                    es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'using your Fire Bolt'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('LowLevel',{'level':9,'power':'Fire Bolt'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Warlock','power':'Fire Bolt'},dnds.getPlayer(userid)['playerlib'].get('lang')))
def boltRun(userid):
    target = int(es.ServerVar('_dnds_temp'))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 300:
            spellCoolDown(userid, 8)
            dnds.Beam(userid, target, 1, 255, 0, 0)
            damage = random.randint(6, 36)+dnds.statMod(userid, 'Constitution')*3
            es.tell(userid, '#multi', dnds.text('PowerHit',{'name':es.getplayername(target),'damage':damage,'power':'Fire Bolt'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            dnds.getPlayer(target)['Player'].Damage(damage, userid, 1)
            flist, olist = dnds.getPlayer(userid)['Player'].NearList(30)
            for id in olist:
                dnds.Beam(target, id, 1, 255, 0, 0)
                damage = random.randint(2, 12)+dnds.statMod(userid, 'Constitution')*3
                es.tell(userid, '#multi', dnds.text('PowerHit',{'name':es.getplayername(id),'damage':damage,'power':'Fire Bolt'},dnds.getPlayer(userid)['playerlib'].get('lang')))
                dnds.getPlayer(target)['Player'].Damage(damage, userid, 1)
        else:
            es.tell(userid, '#multi', dnds.text('toofar',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Warlocks Resillience Power
def resilcmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
            if 'Warlock' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
                level = dnds.getPlayer(userid)['Character'].key['classes']['Warlock']['level']
                if level >= 7:
                    TempHealth(userid, 10+(dnds.statMod(userid, 'Constitution')*5), 10)
                    spellCoolDown(userid, 10)
                else:
                    es.tell(userid, '#multi', dnds.text('LowLevel',{'level':7,'power':'Fiendish Resillience'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Warlock','power':'Fiendish Resillience'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'using your Fiendish Resillience power again'},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Paladin's transpos power
def transposcmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
            if 'Paladin' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
                level = dnds.getPlayer(userid)['Character'].key['classes']['Paladin']['level']
                if level >= 10:
                    es.ServerVar('_dnds_temp').set(0)
                    es.server.queuecmd('est_getviewplayer %s _dnds_temp'%userid)
                    gamethread.delayed(.1, frostRun, (userid))
                else:
                    es.tell(userid, '#multi', dnds.text('LowLevel',{'level':10,'power':'Benign Transposition'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Paladin','power':'Benign Transposition'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'using Benign Transposition again'},dnds.getPlayer(userid)['playerlib'].get('lang')))
def transposRun(userid):
    target = int(es.ServerVar('_dnds_temp'))
    if target:
        if es.getplayerteam(target) == es.getplayerteam(userid):
            x1,y1,z1 = es.getplayerlocation(userid)
            x2,y2,z2 = es.getplayerlocation(target)
            if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 350:
                if Bloodied(target):
                    spellCoolDown(userid, 20)
                    es.server.queuecmd('es_xsetpos %s %s %s %s'%(userid, x1, y1, z1))
                    es.server.queuecmd('es_xsetpos %s %s %s %s'%(target, x2, y2, z2))
                else:
                    es.tell(userid, '#multi', dnds.text('transposRun 1',{'name':es.getplayername(target)},dnds.getPlayer(userid).get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('toofar',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Handles the fighter's Unstoppable power
def unstopcmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
            if 'Fighter' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
                level = dnds.getPlayer(userid)['Character'].key['classes']['Fighter']['level']
                if level >= 6:
                    TempHealth(userid, 10+(dnds.statMod(userid, 'Constitution')*5), 10)
                    spellCoolDown(userid, 25)
                else:
                    es.tell(userid, '#multi', dnds.text('LowLevel',{'level':6,'power':'Unstoppable'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Fighter','power':'Unstoppable'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'using your Unstoppable power again'},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Clerics Cure Light Wounds power
def clwcmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
            if 'Cleric' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
                level = dnds.getPlayer(userid)['Character'].key['classes']['Cleric']['level']
                if level >= 10:
                    es.ServerVar('_dnds_temp').set(0)
                    es.server.queuecmd('est_getviewplayer %s _dnds_temp'%userid)
                    gamethread.delayed(.1, clwRun, (userid))
                else:
                    es.tell(userid, '#multi', dnds.text('LowLevel',{'level':10,'power':'Cure Light Wounds'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Cleric','power':'Cure Light Wounds'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'using your Cure Light Wounds again'},dnds.getPlayer(userid)['playerlib'].get('lang')))
def clwRun(userid):
    target = int(es.ServerVar('_dnds_temp'))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 60:
            HealingSurge(target, spend=False)
            spellCoolDown(userid, 9)
            dnds.Beam(userid, target, 1, 255, 255, 0)
        else:
            es.tell(userid, '#multi', dnds.text('toofar',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Cleric's Guardian of Faith cmd
def guardcmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
            if 'Cleric' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
                level = dnds.getPlayer(userid)['Character'].key['classes']['Cleric']['level']
                if level >= 9:
                    spellCoolDown(userid, 20)
                    for i in range(0, 6, .5):
                        dnds.getPlayer(userid)['Player'].Delayed(i, guardLoop, (userid))
                else:
                    es.tell(userid, '#multi', dnds.text('LowLevel',{'level':9,'power':'Guardian of Faith'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Cleric','power':'Guardian of Faith'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'using your Guardian of Faith again'},dnds.getPlayer(userid)['playerlib'].get('lang')))
def guardLoop(userid):
    flist, olist = dnds.getPlayer(userid)['Player'].NearList(90)
    for id in olist:
        dnds.getPlayer(id).Damage(random.randint(8, 17), userid, 1)
        dnds.Beam(userid, id, 1, 255, 127, 0)
#Wizard Thunderwave Spell
def thundercmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if 'Wizard' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Wizard']['level']
            if level >= 5:
                if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
                    #es.server.cmd('est_viewcone wcs_y %s %s %s 0 %s "es_xdoblock wcs/ViewConeReturn"'%(self.userid, filter, coneSize, coneDistance))
                    es.ServerVar('_dnds_temp').set(0)
                    es.ServerVar('_dnds_userid').set(userid)
                    spellCoolDown(userid, 4.5)
                    es.server.queuecmd('est_viewcone _dnds_temp %s #a 90 0 120 "es_xdoblock dnds/games/pvkiidnds/thunderRun"'%(userid))
                else:
                    es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'casting another spell'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('LowLevel',{'level':5,'power':'Thunderwave'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Wizard','power':'Thunderwave'},dnds.getPlayer(userid)['playerlib'].get('lang')))
def thunderRun():
    userid = int(es.ServerVar('_dnds_userid'))
    target = int(es.ServerVar('_dnds_temp'))
    if not dnds.getPlayer(target)['Player'].key['hold']:
        dnds.getPlayer(target)['playerlib'].set('push', (-25, 0, 0))
    dnds.Beam(userid, target, 1, 255, 255, 0)
    damage = random.randint(2, 15)+dnds.statMod(userid, 'Intelligence')*2
    es.tell(userid, '#multi', dnds.text('PowerHit',{'name':es.getplayername(target),'damage':damage,'power':'Thunderwave'},dnds.getPlayer(userid)['playerlib'].get('lang')))
    dnds.getPlayer(target)['Player'].Damage(damage, userid, 1)
#Wizard Scorching  Burst spell
def burstcmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if 'Wizard' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Wizard']['level']
            if level >= 3:
                if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
                    flist, olist = dnds.getPlayer(userid)['Player'].NearList(50)
                    for id in flist+olist:
                        dnds.Beam(userid, id, 255, 0, 0)
                        spellCoolDown(userid, 4.5)
                        damage = random.randint(2, 15)+dnds.statMod(userid, 'Intelligence')*2
                        es.tell(userid, '#multi', dnds.text('PowerHit',{'name':es.getplayername(id),'damage':damage,'power':'Scorching Burst'},dnds.getPlayer(userid)['playerlib'].get('lang')))
                        dnds.getPlayer(id)['Player'].Damage(damage, userid, 1)
                        if not random.randrange(3):
                            es.server.queuecmd('est_burn %s 3'%id)
                else:
                    es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'casting another spell'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('LowLevel',{'level':3,'power':'Scorching Burst'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Wizard','power':'Scorching Burst'},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Wizard Fire Ball spell
def firecmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if 'Wizard' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Wizard']['level']
            if level >= 10:
                if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
                    es.ServerVar('_dnds_temp').set(0)
                    es.server.queuecmd('est_getviewplayer %s _dnds_temp'%userid)
                    gamethread.delayed(.1, fireRun, (userid))
                else:
                    es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'casting another spell'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('LowLevel',{'level':10,'power':'Fire Ball'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Wizard','power':'Fire Ball'},dnds.getPlayer(userid)['playerlib'].get('lang')))
def fireRun(userid):
    target = int(es.ServerVar('_dnds_temp'))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 300:
            spellCoolDown(userid, 15)
            dnds.Beam(userid, target, 1, 255, 0, 0)
            damage = random.randint(3, 18)+dnds.statMod(userid, 'Intelligence')*2
            es.tell(userid, '#multi', dnds.text('PowerHit',{'name':es.getplayername(target),'damage':damage,'power':'Fire Ball'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            dnds.getPlayer(target)['Player'].Damage(damage, userid, 1)
            if damage >= 15:
                es.server.queuecmd('est_burn %s 3'%target)
            flist, olist = dnds.getPlayer(target)['Player'].NearList(240)
            for id in flist+olist:
                dnds.Beam(target, id, 1, 255, 0, 0)
                damage = random.randint(3, 18)+dnds.statMod(userid, 'Intelligence')*2
                es.tell(userid, '#multi', dnds.text('PowerHit',{'name':es.getplayername(id),'damage':damage,'power':'Fire Ball'},dnds.getPlayer(userid)['playerlib'].get('lang')))
                dnds.getPlayer(id)['Player'].Damage(damage, userid, 1)
                if damage >= 15:
                    es.server.queuecmd('est_burn %s 3'%id)
        else:
            es.tell(userid, '#multi', dnds.text('toofar',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Wizard Forst Spell
def frostcmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if 'Wizard' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Wizard']['level']
            if level >= 2:
                if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
                    es.ServerVar('_dnds_temp').set(0)
                    es.server.queuecmd('est_getviewplayer %s _dnds_temp'%userid)
                    gamethread.delayed(.1, frostRun, (userid))
                else:
                    es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'casting another spell'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('LowLevel',{'level':2,'power':'Ray of Frost'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Wizard','power':'Ray of Frost'},dnds.getPlayer(userid)['playerlib'].get('lang')))
def frostRun(userid):
    target = int(es.ServerVar('_dnds_temp'))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 300:
            spellCoolDown(userid, 2.5)
            dnds.Beam(userid, target, 1, 0, 204, 204)
            dnds.getPlayer(target)['playerlib'].set('speed', dnds.getPlayer(target)['playerlib'].get('speed')-.3)
            dnds.getPlayer(target)['Player'].Delayed(4, dnds.getPlayer(target)['playerlib'].set, ('speed', dnds.getPlayer(target)['playerlib'].get('speed')+.3))
            damage = random.randint(2, 15)+dnds.statMod(userid, 'Intelligence')*2
            es.tell(userid, '#multi', dnds.text('PowerHit',{'name':es.getplayername(target),'damage':damage,'power':'Ray of Frost'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            dnds.getPlayer(target)['Player'].Damage(damage, userid, 1)
        else:
            es.tell(userid, '#multi', dnds.text('toofar',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Wizard ice rays spell
def icecmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if 'Wizard' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Wizard']['level']
            if level >= 9:
                if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
                    es.ServerVar('_dnds_temp').set(0)
                    es.server.queuecmd('est_getviewplayer %s _dnds_temp'%userid)
                    gamethread.delayed(.1, iceRun, (userid))
                else:
                    es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'casting another spell'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('LowLevel',{'level':9,'power':'Ice Rays'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Wizard','power':'Ice Rays'},dnds.getPlayer(userid)['playerlib'].get('lang')))
def iceRun(userid):
    target = int(es.ServerVar('_dnds_temp'))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 300:
            spellCoolDown(userid, 10)
            dnds.Beam(userid, target, 1, 0, 204, 204)
            damage = random.randint(3, 20)+dnds.statMod(userid, 'Intelligence')*2
            es.tell(userid, '#multi', dnds.text('PowerHit',{'name':es.getplayername(target),'damage':damage,'power':'Ice Rays'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            dnds.getPlayer(target)['Player'].Damage(damage, userid, 1)
            dnds.getPlayer(target)['Player'].Freeze(3)
            flist, olist = dnds.getPlayer(target)['Player'].NearList(100)
            if len(olist):
                id = random.choice(olist)
                dnds.Beam(userid, id, 1, 0, 204, 204)
                damage = random.randint(3, 20)+dnds.statMod(userid, 'Intelligence')*2
                dnds.getPlayer(id)['Player'].Freeze(3)
                es.tell(userid, '#multi', dnds.text('PowerHit',{'name':es.getplayername(id),'damage':damage,'power':'Ice Rays'},dnds.getPlayer(userid)['playerlib'].get('lang')))
                dnds.getPlayer(id)['Player'].Damage(damage, userid, 1)
        else:
            es.tell(userid, '#multi', dnds.text('toofar',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Wizard Acid Arrow spell
def acidcmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if 'Wizard' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Wizard']['level']
            if level >= 6:
                if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
                    es.ServerVar('_dnds_temp').set(0)
                    es.server.queuecmd('est_getviewplayer %s _dnds_temp'%userid)
                    gamethread.delayed(.1, acidRun, (userid))
                else:
                    es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'casting another spell'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('LowLevel',{'level':7,'power':'Acid Arrow'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Wizard','power':'Acid Arrow'},dnds.getPlayer(userid)['playerlib'].get('lang')))
def acidRun(userid):
    target = int(es.ServerVar('_dnds_temp'))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 300:
            spellCoolDown(userid, 15)
            dnds.Beam(userid, target, 1, 0, 255, 0)
            damage = random.randint(2, 16)+dnds.statMod(userid, 'Intelligence')*2
            for i in range(1, 9):
                dnds.getPlayer(target)['Player'].Delayed(i, dnds.getPlayer(target)['Player'].Damage, (5, userid, 1))
            es.tell(userid, '#multi', dnds.text('PowerHit',{'name':es.getplayername(target),'damage':damage,'power':'Acid Arrow'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            dnds.getPlayer(target)['Player'].Damage(damage, userid, 1)
            flist, olist = dnds.getPlayer(target)['Player'].NearList(50)
            for id in olist:
                dnds.Beam(target, id, 1, 0, 255, 0)
                for i in range(1, 9):
                    dnds.getPlayer(id)['Player'].Delayed(i, dnds.getPlayer(id)['Player'].Damage, (2, userid, 1))
                damage = damage/2
                es.tell(userid, '#multi', dnds.text('PowerHit',{'name':es.getplayername(id),'damage':damage,'power':'Acid Arrow'},dnds.getPlayer(userid)['playerlib'].get('lang')))
                dnds.getPlayer(id)['Player'].Damage(damage, userid, 1)
        else:
            es.tell(userid, '#multi', dnds.text('toofar',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Wizard Ray of EnfeeblementSpell
def enfeeblecmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if 'Wizard' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Wizard']['level']
            if level >= 6:
                if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
                    es.ServerVar('_dnds_temp').set(0)
                    es.server.queuecmd('est_getviewplayer %s _dnds_temp'%userid)
                    gamethread.delayed(.1, enfeebleRun, (userid))
                else:
                    es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'casting another spell'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('LowLevel',{'level':6,'power':'Ray of Enfeeblement'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Wizard','power':'Ray of Enfeeblement'},dnds.getPlayer(userid)['playerlib'].get('lang')))
def enfeebleRun(userid):
    target = int(es.ServerVar('_dnds_temp'))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 300:
            spellCoolDown(userid, 6)
            dnds.Beam(userid, target, 1, 0, 200, 0)
            dnds.getPlayer(target)['Player'].key['weakened'] += 1
            dnds.getPlayer(target)['Player'].Delayed(5, dnds.getPlayer(victim)['Player'].KeyMod, ('weakened', -1))
            damage = random.randint(3, 25)+dnds.statMod(userid, 'Intelligence')*2
            es.tell(userid, '#multi', dnds.text('PowerHit',{'name':es.getplayername(target),'damage':damage,'power':'Ray of Enfeeblement'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            dnds.getPlayer(target)['Player'].Damage(damage, userid, 1)
        else:
            es.tell(userid, '#multi', dnds.text('toofar',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Wizard Missle Spell
def missilecmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if 'Wizard' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Wizard']['level']
            if level >= 1:
                if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
                    es.ServerVar('_dnds_temp').set(0)
                    es.server.queuecmd('est_getviewplayer %s _dnds_temp'%userid)
                    gamethread.delayed(.1, missileRun, (userid))
                else:
                    es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'casting another spell'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('LowLevel',{'level':1,'power':'Magic Missile'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Wizard','power':'Magic Missile'},dnds.getPlayer(userid)['playerlib'].get('lang')))
def missileRun(userid):
    target = int(es.ServerVar('_dnds_temp'))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 600:
            spellCoolDown(userid, 2)
            dnds.Beam(userid, target, 1, 0, 0, 0)
            damage = random.randint(3, 18)+dnds.statMod(userid, 'Intelligence')*2
            es.tell(userid, '#multi', dnds.text('PowerHit',{'name':es.getplayername(target),'damage':damage,'power':'Magic Missile'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            dnds.getPlayer(target)['Player'].Damage(damage, userid, 1)
        else:
            es.tell(userid, '#multi', dnds.text('toofar',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Warlocks blast command
def blastcmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if 'Warlock' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Warlock']['level']
            if level >= 1:
                if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
                    es.ServerVar('_dnds_temp').set(0)
                    es.server.queuecmd('est_getviewplayer %s _dnds_temp'%userid)
                    gamethread.delayed(.1, blastRun, (userid))
                else:
                    es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'using your Eldritch Blast again'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('LowLevel',{'level':1,'power':'Eldritch Blast'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Warlock','power':'Eldritch Blast'},dnds.getPlayer(userid)['playerlib'].get('lang')))
def blastRun(userid):
    target = int(es.ServerVar('_dnds_temp'))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 600:
            spellCoolDown(userid, 4)
            if dnds.getPlayer(userid)['Character'].key['abilities']['Constitution'] > dnds.getPlayer(userid)['Character'].key['abilities']['Charisma']:
                stat = 'Constitution'
            else:
                stat = 'Charisma'
            dnds.Beam(userid, target, 1, 139, 0, 139)
            damage = random.randint(3, 30)+dnds.statMod(userid, stat)*2
            es.tell(userid, '#multi', dnds.text('PowerHit',{'name':es.getplayername(target),'damage':damage,'power':'Eldritch Blast'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            dnds.getPlayer(target)['Player'].Damage(damage, userid, 1)
        else:
            es.tell(userid, '#multi', dnds.text('toofar',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Ranger's wolv command
def wolvcmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if 'Ranger' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Ranger']['level']
            if level >= 3:
                if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
                    if dnds.getPlayer(userid)['playerlib'].get('weapon') == 'axesword':
                        flist, olist = dnds.getPlayer(userid)['Player'].NearList(60)
                        spellCoolDown(userid, 15)
                        for id in olist:
                            dnds.getPlayer(id)['Player'].Damage(random.randint(13,27),userid)
                else:
                    es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'using your Dire Wolverine Strike again'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('LowLevel',{'level':3,'power':'Dire Wolverine Strike'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Ranger','power':'Dire Wolverine Strike'},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Paladin's hands command
def handscmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        if 'Paladin' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Paladin']['level']
            if level >= 2:
                es.ServerVar('_dnds_temp').set(0)
                es.server.queuecmd('est_getviewplayer %s _dnds_temp'%userid)
                gamethread.delayed(.1, handsRun, (userid))
            else:
                es.tell(userid, '#multi', dnds.text('LowLevel',{'level':2,'power':'Lay on Hands'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Paladin','power':'Lay on Hands'},dnds.getPlayer(userid)['playerlib'].get('lang')))
def handsRun(userid):
    target = int(es.ServerVar('_dnds_temp'))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 20:
            HealingSurge(target, userid)
            if 'Healing Hands' in dnds.getPlayer(userid)['Character'].key['feats']:
                Heal(target, dnds.getPlayer(userid)['Character'].key['abilities']['Charisma'])
                es.tell(userid, '#multi', dnds.text('handsRun 1',{'name':es.getplayername(target),'amount':dnds.getPlayer(userid)['Character'].key['abilities']['Charisma']},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('handsRun 2',{'name':es.getplayername(target)},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('toofar',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Cleric's word command
def wordcmd():
    #es.msg('wordcmd')
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        dnds.report('%s ran the wordcmd in chat/console'%es.getplayername(userid))
        if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
            level = 0
            if 'Cleric' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
                level = dnds.getPlayer(userid)['Character'].key['classes']['Cleric']['level']
            elif 'Warlord' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
                level = dnds.getPlayer(userid)['Character'].key['classes']['Warlord']['level']
            else:
                es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Cleric or Warlord','power':'Word'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            if level >= 1:
                es.ServerVar('_dnds_temp').set(0)
                es.server.queuecmd('est_getviewplayer %s _dnds_temp'%userid)
                gamethread.delayed(.1, wordRun, (userid, level))
            else:
                es.tell(userid, '#multi', dnds.text('LowLevel',{'level':1,'power':'Word'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'using your Word again'},dnds.getPlayer(userid)['playerlib'].get('lang')))
def wordRun(userid, level):
    target = int(es.ServerVar('_dnds_temp'))
    #es.msg('Target = %s'%target)
    #es.msg('Word Run')
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 200+(level*10):
            spellCoolDown(userid, 15)
            HealingSurge(target)
            if level < 6:
                amount = random.randint(2, 8)
            elif level < 11:
                amount = random.randint(4, 16)
            elif level < 16:
                amount = random.randint(6, 24)
            elif level < 21:
                amount = random.randint(8, 30)
            elif level < 26:
                amount = random.randint(10, 36)
            else:
                amount = random.randint(12, 44)
            Heal(target, amount)
            es.tell(userid, '#multi', dnds.text('wordRun 1',{'name':es.getplayername(target),'amount':amount},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('toofar',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Cleric's glow command
def glowcmd():
    userid = int(es.getcmduserid())
    if not int(es.getplayerprop(userid, "CBasePlayer.pl.deadflag")):
        dnds.report('%s ran the glowcmd in chat/console'%es.getplayername(userid))
        if not dnds.getPlayer(userid)['Player'].key['spell cool down']:
            if 'Cleric' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
                level = dnds.getPlayer(userid)['Character'].key['classes']['Cleric']['level']
                if level >= 5:
                    spellCoolDown(userid, 15)
                    flist, olist = dnds.getPlayer(userid)['Player'].NearList(240)
                    team = es.getplayerteam(userid)
                    for id in olist:
                        dnds.getPlayer(id)['Player'].Damage(random.randint(14,33),userid)
                        dnds.Beam(userid, id, 1, 128, 42, 42)
                    for id in flist:
                        dnds.Beam(userid, id, 1, 0, 0, 0)
                        dnds.getPlayer(id)['Player'].key['buff'] += .1
                        dnds.getPlayer(id)['Player'].Delayed(6, dnds.getPlayer(id)['Player'].KeyMod, ('buff', -.1))
                else:
                    es.tell(userid, '#multi', dnds.text('LowLevel',{'level':5,'power':'Divine Glow'},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('WrongClass',{'class':'Cleric','power':'Divine Glow'},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('cooldown',{'cooldown':dnds.getPlayer(userid)['Player'].key['spell cool down'],'text':'using your Divine Glow again'},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Controls the rogue's stealth as he toggles it with his walk key on/off
def StealthOn(userid):
    if 'Rogue' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
        if not dnds.getPlayer(userid)['Player'].key['stealth delay'] and not dnds.getPlayer(userid)['Player'].key['stealthed']:
            es.tell(userid, '#multi', dnds.text('StealthOn 1',{},dnds.getPlayer(userid).get('lang')))
            dnds.getPlayer(userid)['Player'].key['stealthed'] = 1
            dnds.getPlayer(userid)['Player'].key['stealth key'] = 1
            es.server.queuecmd('est_setplayercolor %s 255 255 255 %s 1'%(userid, 75-dnds.statMod(userid, 'Dexterity')*7))
def StealthOff(userid):
    if 'Rogue' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
        es.tell(userid, '#multi', dnds.text('StealthOff 1',{},dnds.getPlayer(userid).get('lang')))
        es.server.queuecmd('est_setplayercolor %s 255 255 255 255 1'%userid)
        dnds.getPlayer(userid)['Player'].key['stealthed'] = 0
        dnds.getPlayer(userid)['Player'].key['stealth key'] = 0
def StealthDown(userid):
    es.server.queuecmd('est_setplayercolor %s 255 255 255 255 1'%userid)
    if dnds.getPlayer(userid)['Player'].key['stealthed']:
        es.tell(userid, '#multi', dnds.text('StealthDown 1',{},dnds.getPlayer(userid).get('lang')))
        dnds.getPlayer(userid)['Player'].key['stealthed'] = 0
    dnds.getPlayer(userid)['Player'].key['stealth delay'] += 1
    dnds.getPlayer(userid)['Player'].Delayed(3, StealthReady, userid)
def StealthReady(userid):
    dnds.getPlayer(userid)['Player'].key['stealth delay'] -= 1
    if dnds.getPlayer(userid)['Player'].key['stealth key']:
        StealthOn(userid)
#Begin +wind and -wind
def WindOn():
    userid = int(es.getcmduserid())
    if es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth') != es.getplayerprop(userid, 'CBasePlayer.m_iHealth'):
        if not dnds.getPlayer(userid)['Player'].key['wind used']:
            if dnds.getPlayer(userid)['Player'].key['healing surges']:
                dnds.getPlayer(userid)['Player'].key['wind on'] = 1
                dnds.getPlayer(userid)['Player'].Delayed(1, WindLoop, (userid, 1))
                dnds.getPlayer(userid)['Player'].Freeze()
                es.tell(userid, '#multi', dnds.text('WindOn 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
            else:
                es.tell(userid, '#multi', dnds.text('WindOn 2',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('WindOn 3',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
    else:
        es.tell(userid, '#multi', dnds.text('WindOn 4',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
def WindOff():
    userid = int(es.getcmduserid())
    if dnds.getPlayer(userid)['Player'].key['wind on']:
        dnds.getPlayer(userid)['Player'].Unfreeze()
        dnds.getPlayer(userid)['Player'].key['wind on'] = 0
def WindLoop(userid, count):
    if count < 3 and dnds.getPlayer(userid)['Player'].key['wind on']:
        dnds.getPlayer(userid)['Player'].Delayed(1, WindLoop, (userid, count+1))
    elif count == 3:
        WindRun(userid)
def WindRun(userid):
    dnds.getPlayer(userid)['Player'].key['wind used'] = 1
    HealingSurge(userid)
    dnds.getPlayer(userid)['Player'].Unfreeze()
    dnds.getPlayer(userid)['Player'].key['wind on'] = 0
    dnds.getPlayer(userid)['Player'].Delayed(20, WindWipe, userid)
def WindWipe(userid):
    dnds.getPlayer(userid)['Player'].key['wind used'] = 0
    if dnds.getPlayer(userid)['Player'].key['healing surges']:
        es.tell(userid, '#multi', dnds.text('WindWipe 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#End Command Methods
#Global Methods
#Helps me break down events and pass in key info about users
def PlayerHurt(userid, attacker, damage, weapon, Classes, Character):
    Dead = dnds.getPlayer(userid)['playerlib'].get('isdead')
    Dodged = 0
    dexmod = dnds.statMod(userid, 'Dexterity')*4
    intmod = dnds.statMod(userid, 'Intelligence')*4
    if not Dead:
        chance = random.randint(1, 100)
        if dexmod > intmod:
            if dexmod >= chance:
                Dodged = 1
                Heal(userid, damage)
                es.tell(userid, '#multi', dnds.text('PlayerHurt 1',{'damage':damage,'stat':'Dexterity'},dnds.getPlayer(userid).get('lang')))
        else:
            if intmod >= chance:
                Dodged = 1
                Heal(userid, damage)
                es.tell(userid, '#multi', dnds.text('PlayerHurt 1',{'damage':damage,'stat':'Intelligence'},dnds.getPlayer(userid).get('lang')))
    if 'Cleric' in Classes:
        level = Character.key['classes']['Cleric']['level']
        if level >= 2 and not Dodged:
            Heal(userid, damage/10)
    if 'Fighter' in Classes:
        level = Character.key['classes']['Fighter']['level']
        if level >= 9 and not Dodged and not Dead:
            Heal(userid, damage*.1)
    if 'Ranger' in Classes:
        level = Character.key['classes']['Ranger']['level']
        if level >= 6 and dnds.getPlayer(userid)['Player'].key['blocking']:
            dnds.getPlayer(userid)['playerlib'].set('viewcoord', (random.randint(-1000, 1000),random.randint(-1000, 1000),random.randint(-1000, 1000)))
    if 'Rogue' in Classes:
        level = Character.key['classes']['Rogue']['level']
        if dnds.getPlayer(userid)['Player'].key['stealthed']:
            StealthDown(userid)
        if level >= 3:
            if dnds.getPlayer(userid)['Player'].key['blocking']:
                dnds.getPlayer(attacker).Damage(random.randint(13, 37), userid)
    if 'Warlock' in Classes:
        level = Character.key['classes']['Warlock']['level']
        if level >= 2:
            if not random.randrange(9):
                es.server.queuecmd('est_burn %s 3'%attacker)
                es.tell(userid, '#multi', dnds.text('PlayerHurt 2',{'name':es.getplayername(attacker)},dnds.getPlayer(userid).get('lang')))
    if not Dead:
        if dnds.getPlayer(userid)['Player'].key['wl aura'] and not Dodged:
            Heal(userid, damage*.1)
        if dnds.getPlayer(userid)['Player'].key['pa aura'] and not Dodged:
            Heal(userid, damage*.1)
    if dnds.getPlayer(userid)['Player'].key['wl strike']:
        if es.getplayerteam(attacker) == dnds.getPlayer(userid)['Player'].key['wl strike'][0] and attacker != dnds.getPlayer(userid)['Player'].key['wl strike'][1]:
            dnds.getPlayer(userid)['Player'].Damage(damage*.2,attacker)
def PlayerHit(userid, victim, damage, weapon, Classes, Character):
    MeeleBuff = 1
    if 'Cleric' in Classes:
        level = Character.key['classes']['Cleric']['level']
        if level >= 3:
            if not random.randrange(5):
                dnds.getPlayer(victim)['Player'].Damage(damage*.4,userid)
                if not random.randrange(3):
                    es.server.queuecmd('est_burn %s 3'%victim)
        if level >= 6:
            if not random.randrange(8):
                dnds.getPlayer(victim)['Player'].Freeze(1.5)
                es.tell(userid, '#multi', dnds.text('PlayerHit 11',{'name':es.getplayername(victim)},dnds.getPlayer(userid).get('lang')))
        if level >= 7:
            if not random.randrange(10):
                flist, olist = dnds.getPlayer(userid)['Player'].NearList(80)
                for f in flist:
                    Heal(f, 10)
                Heal(userid, 10)
    if 'Fighter' in Classes:
        level = Character.key['classes']['Fighter']['level']
        if level >= 1:
            if weapon in Meele_Weapons:
                flist, olist = dnds.getPlayer(userid)['Player'].NearList(20)
                if len(olist):
                    id = random.choice(olist)
                else:
                    id = None
                if id:
                    dnds.getPlayer(id)['Player'].Damage(damage*(.05*dnds.statMod(userid, 'Strength')),userid)
        if level >= 2:
            if weapon in Meele_Weapons:
                if not random.randrange(4):
                    if not dnds.getPlayer(victim)['Player'].key['hold']:
                        dnds.getPlayer(victim)['playerlib'].set('push', (-25, 0, 0))
                        es.tell(userid, '#multi', dnds.text('PlayerHit 1',{'name':es.getplayername(victim)},dnds.getPlayer(userid).get('lang')))
        if level >= 3:
            if weapon in Meele_Weapons:
                if not random.randrange(19):
                    dnds.getPlayer(victim)['playerlib'].set('speed', dnds.getPlayer(victim)['playerlib'].get('speed')-.2)
                    dnds.getPlayer(victim)['Player'].Delayed(4, dnds.getPlayer(victim)['playerlib'].set, ('speed', dnds.getPlayer(userid)['playerlib'].get('speed')+.2))
                    es.tell(userid, '#multi', dnds.text('PlayerHit 2',{'name':es.getplayername(victim)},dnds.getPlayer(userid).get('lang')))
        if level >= 5:
            if weapon in Meele_Weapons:
                if Bloodied(userid):
                    if not random.randrange(9):
                        if dnds.getPlayer(userid)['Player'].key['healing surges']:
                            es.tell(userid, '#multi', dnds.text('PlayerHit 3',{},dnds.getPlayer(userid).get('lang')))
                            HealingSurge(userid)
        if level >= 7:
            if weapon in Meele_Weapons:
                dnds.getPlayer(victim)['Player'].Damage(damage*(.05*dnds.statMod(userid, 'Constitution')),userid)
    if 'Paladin' in Classes:
        level = Character.key['classes']['Paladin']['level']
        if level >= 1:
            if weapon in Meele_Weapons:
                dnds.getPlayer(victim)['Player'].Damage(damage*(.05*dnds.statMod(userid, 'Strength')),userid)
        if level >= 3:
            if weapon in Meele_Weapons:
                dnds.getPlayer(victim)['Player'].Damage(damage*(.05*dnds.statMod(userid, 'Wisdom')),userid)
        if level >= 5:
            if weapon in Meele_Weapons:
                if not random.randrange(5):
                    es.tell(userid, '#multi', dnds.text('PlayerHit 4',{'name':es.getplayername(victim)},dnds.getPlayer(userid).get('lang')))
                    dnds.getPlayer(victim)['Player'].Freeze(1)
        if level >= 7:
            if weapon in Meele_Weapons:
                if not random.randrange(7):
                    flist, olist = dnds.getPlayer(userid)['Player'].NearList(90)
                    for id in flist:
                        if Bloodied(id):
                            Heal(id, 10)
                    if Bloodied(userid):
                        Heal(userid, 10)
        if level >= 9:
            if weapon in Meele_Weapons:
                if not random.randrange(4):
                    if not dnds.getPlayer(victim)['Player'].key['hold']:
                        dnds.getPlayer(victim)['playerlib'].set('push', (-25, 0, 0))
                        es.tell(userid, '#multi', dnds.text('PlayerHit 1',{'name':es.getplayername(victim)},dnds.getPlayer(userid).get('lang')))
    if 'Rogue' in Classes:
        level = Character.key['classes']['Rogue']['level']
        if level >= 1:
            if dnds.getPlayer(userid)['Player'].key['stealthed']:
                if 'Backstabber' in Character.key['feats']:
                    range = 8
                else:
                    range = 6
                if level < 10:
                    dice = 4
                elif level < 20:
                    dice = 6
                else:
                    dice = 10
                amount = 0
                while dice > 0:
                    dice -= 1
                    amount += random.randint(1, range)
                dnds.getPlayer(victim)['Player'].Damage(amount,userid)
                es.tell(userid, '#multi', dnds.text('PlayerHit 5',{'name':es.getplayername(victim),'amount':amount},dnds.getPlayer(userid).get('lang')))
        if level >= 2:
            MeeleBuff = 0
            dnds.getPlayer(victim)['Player'].Damage(damage*(.05*dnds.statMod(userid, 'Dexterity')),userid)
        if level >= 5:
            if weapon in Meele_Weapons:
                if not random.randrange(19):
                    dnds.getPlayer(victim)['Player'].Damage(damage, userid)
                    es.tell(userid, '#multi', dnds.text('PlayerHit 6',{'amount':damage},dnds.getPlayer(userid).get('lang')))
        if level >= 6:
            if weapon == 'flintlock':
                if not random.randrange(7):
                    dnds.Blind(victim, 2)
                    es.tell(userid, '#multi', dnds.text('PlayerHit 12',{'name':es.getplayername(victim)},dnds.getPlayer(userid).get('lang')))
        if level >= 9:
            if weapon in Meele_Weapons:
                if not random.randrange(9):
                    dnds.getPlayer(victim)['playerlib'].set('speed', dnds.getPlayer(victim)['playerlib'].get('speed')-.2)
                    dnds.getPlayer(victim)['Player'].Delayed(4, dnds.getPlayer(victim)['playerlib'].set, ('speed', dnds.getPlayer(userid)['playerlib'].get('speed')+.2))
                    es.tell(userid, '#multi', dnds.text('PlayerHit 13',{'name':es.getplayername(victim)},dnds.getPlayer(userid).get('lang')))
        if level >= 10:
            if weapon in Meele_Weapons:
                if not random.randrange(12):
                    for i in range(1, 7):
                        dnds.getPlayer(victim)['Player'].Delayed(i, dnds.getPlayer(victim)['Player'].Damage, (5, userid))
                    es.tell(userid, '#multi', dnds.text('PlayerHit 14',{'name':es.getplayername(victim)},dnds.getPlayer(userid).get('lang')))
        StealthDown(userid)
    if 'Ranger' in Classes:
        level = Character.key['classes']['Ranger']['level']
        type = Character.key['weapon type']
        if level >= 2:
            if not random.randrange(19):
                bonus = random.randint(13, 27)
                dnds.getPlayer(victim)['Player'].Damage(bonus,userid)
                es.tell(userid, '#multi', dnds.text('PlayerHit 7',{'amount':bonus},dnds.getPlayer(userid).get('lang')))
        if level >= 5:
            if not random.randrange(19):
                es.tell(userid, '#multi', dnds.text('PlayerHit 8',{'name':es.getplayername(victim)},dnds.getPlayer(userid).get('lang')))
                dnds.getPlayer(victim)['playerlib'].set('speed', dnds.getPlayer(victim)['playerlib'].get('speed')-.2)
                dnds.getPlayer(victim)['Player'].Delayed(4, dnds.getPlayer(victim)['playerlib'].set, ('speed', dnds.getPlayer(userid)['playerlib'].get('speed')+.2))
        if level >= 7:
            if weapon in ['axesword','longbow']:
                if not random.randrange(5):
                    if not dnds.getPlayer(victim)['Player'].key['hold']:
                        dnds.getPlayer(victim)['playerlib'].set('push', (-25, 0, 0))
        if type == 'archer':
            if level >= 1:
                if weapon in Ranged_Weapons:
                    dnds.getPlayer(victim)['Player'].Damage(damage*(.05*dnds.statMod(userid, 'Dexterity')),userid)
            if level >= 3:
                if weapon in Ranged_Weapons:
                    dnds.getPlayer(victim)['Player'].Damage(damage*(.05*dnds.statMod(userid, 'Wisdom')),userid)
            if level >= 6:
                if weapon in Ranged_Weapons:
                    flist, olist = dnds.getPlayer(victim)['Player'].NearList(30)
                    if len(flist):
                        dnds.getPlayer(random.choice(olist))['Player'].Damage(damage/2,userid)
            if level >= 9:
                if weapon in Ranged_Weapons:
                    if not random.randrange(9):
                        dnds.getPlayer(victim)['Player'].key['weakened'] += 1
                        dnds.getPlayer(victim)['Player'].Delayed(5, dnds.getPlayer(victim)['Player'].KeyMod, ('weakened', -1))
        if type == 'two weapon':
            if level >= 1:
                if weapon in Meele_Weapons:
                    dnds.getPlayer(userid)['playerlib'].set('speed', dnds.getPlayer(userid)['playerlib'].get('speed')+.15)
                    dnds.getPlayer(userid)['Player'].Delayed(1.75, dnds.getPlayer(userid)['playerlib'].set, ('speed', dnds.getPlayer(userid)['playerlib'].get('speed')-.15))
            if level >= 9:
                if weapon == 'axesword':
                    if not random.randrange(10):
                        flist, olist = dnds.getPlayer(userid)['Player'].NearList(20)
                        x,y,z = es.getplayerlocation(userid)
                        for id in olist:
                            if not dnds.getPlayer(id)['Player'].key['hold']:
                                dnds.getPlayer(id)['playerlib'].set('push', (-25, 0, 0))
                                dnds.getPlayer(id)['Player'].Damage(damage/2,userid)
    if 'Warlock' in Classes:
        level = Character.key['classes']['Warlock']['level']
        if level >= 3:
            if weapon in Meele_Weapons:
                Heal(userid, damage*.2)
        if level >= 5:
            if not random.randrange(14):
                dnds.getPlayer(victim)['Player'].Freeze(2)
                es.tell(userid, '#multi', dnds.text('PlayerHit 9',{'name':es.getplayername(victim)},dnds.getPlayer(userid).get('lang')))
        if level >= 6:
            if not random.randrange(7):
                es.server.queuecmd('est_burn %s 3'%victim)
                es.tell(userid, '#multi', dnds.text('PlayerHit 15',{'name':es.getplayername(victim)},dnds.getPlayer(userid).get('lang')))
    if 'Warlord' in Classes:
        level = Character.key['classes']['Warlord']['level']
        if level >= 2:
            if weapon in Meele_Weapons:
                x,y,z = es.getplayerlocation(victim)
                dnds.getPlayer(userid)['Player'].Delayed(2, viperStrike, (victim, userid, damage, x,y,z))
        if level >= 3:
            if weapon in Meele_Weapons:
                if not random.randrange(19):
                    x1,y1,z1 = es.getplayerlocation(victim)
                    x2,y2,z2 = es.getplayerlocation(userid)
                    es.server.queuecmd('es_xsetpos %s %s %s %s'%(userid, x1, y1, z1))
                    es.server.queuecmd('es_xsetpos %s %s %s %s'%(victim, x2, y2, z2))
                    es.server.queuecmd('playerset viewplayer %s %s'%(userid, victim))
                    es.tell(userid, '#multi', dnds.text('PlayerHit 10',{'name':es.getplayername(victim)},dnds.getPlayer(userid).get('lang')))
        if level >= 9:
            if weapon in Meele_Weapons:
                dnds.getPlayer(victim)['Player'].key['wl strike'] = [es.getplayerteam(userid), userid]
                dnds.getPlayer(victim)['Player'].Delayed(6, dnds.getPlayer(victim)['Player'].Key, ('wl strike', 0))
    if 'Power Attack' in Character.key['feats']:
        if weapon in Meele_Weapons:
            dnds.getPlayer(victim)['Player'].Damage(damage*.1,userid)
    if 'Dwarven Weapon Training' in Character.key['feats']:
        if weapon in Axes:
            dnds.getPlayer(victim)['Player'].Damage(damage*.15,userid)
    if 'Eladrin Soldier' in Character.key['feats']:
        if weapon in Swords:
            dnds.getPlayer(victim)['Player'].Damage(damage*.1,userid)
    if weapon in Meele_Weapons and MeeleBuff:
        dnds.getPlayer(victim)['Player'].Damage(damage*(.05*dnds.statMod(userid, 'Strength')),userid)
    if dnds.getPlayer(userid)['Player'].key['buff']:
        dnds.getPlayer(victim)['Player'].Damage(damage*dnds.getPlayer(userid)['Player'].key['buff'],userid)
    if dnds.getPlayer(userid)['Player'].key['weakened']:
        dnds.getPlayer(victim)['Player'].Heal(damage*.3)
    if dnds.getPlayer(userid)['Player'].key['marked']:
        if dnds.getPlayer(userid)['Player'].key['marked'] != victim:
            dnds.getPlayer(victim)['Player'].Heal(damage*.5)
#Handels the check for warlord's Viper Strike
def viperStrike(userid, attacker, damage,x1,y1,z1):
    x2,y2,z2 = es.getplayerlocation(userid)
    if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 20:
        dnds.getPlayer(userid)['Player'].Damage(damage/2, attacker)
#Loop for the auras
def defenseAura(userid, clas):
    flist, olist = dnds.getPlayer(userid)['Player'].NearList(90)
    for id in dnds.getPlayer(userid)['Player'].key['%s list'%clas]:
        dnds.getPlayer(id)['Player'].key['%s aura'%clas] = 0
    dnds.getPlayer(userid)['Player'].key['%s list'%clas].clear()
    for id in flist:
        dnds.getPlayer(id)['Player'].key['%s aura'%clas] = 1
        dnds.getPlayer(userid)['Player'].key['%s list'%clas].append(id)
    dnds.getPlayer(userid)['Player'].Delayed(1, defenseAura, (userid,clas))
def holdAura(userid, clas):
    flist, olist = dnds.getPlayer(userid)['Player'].NearList(90)
    for id in dnds.getPlayer(userid)['Player'].key['%s hlist'%clas]:
        dnds.getPlayer(id)['Player'].key['%s aura'%clas] = 0
    dnds.getPlayer(userid)['Player'].key['%s hlist'%clas].clear()
    for id in flist:
        dnds.getPlayer(id)['Player'].key['%s aura'%clas] = 1
        dnds.getPlayer(userid)['Player'].key['%s hlist'%clas].append(id)
    dnds.getPlayer(userid)['Player'].Delayed(1, defenseAura, (userid,clas))
def BoundlessLoop(userid):
    if Bloodied(userid):
        Heal(userid, 2+dnds.statMod(userid, 'Constitution'))
    dnds.getPlayer(userid)['Player'].Delayed(3, BoundlessLoop, userid)
#Some core commands we use
def HealingSurge(userid, user=None, spend=True):
    if not user:
        hs = dnds.getPlayer(userid)['Player'].key['healing surges']
    else:
        hs = dnds.getPlayer(user)['Player'].key['healing surges']
    if hs:
        if es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth') != es.getplayerprop(userid, 'CBasePlayer.m_iHealth'):
            Surge = (int(es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth'))/2)/2
            Heal(userid, Surge)
            if spend:
                if not user:
                    dnds.getPlayer(userid)['Player'].key['healing surges'] -= 1
                else:
                    dnds.getPlayer(user)['Player'].key['healing surges'] -= 1
            es.tell(userid, '#multi', dnds.text('HealingSurge 1',{'surge':Surge,'remaining':dnds.getPlayer(userid)['Player'].key['healing surges']},dnds.getPlayer(userid)['playerlib'].get('lang')))
def Heal(userid, amount):
    if not int(dnds.getPlayer(userid)['playerlib'].get('isdead')):
        Health = int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth'))
        MaxHealth = int(es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth'))
        if (Health+amount) <= MaxHealth:
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', Health+amount)
        else:
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', MaxHealth)
def TempHealth(userid, amount, time=None):
    for prop in ['CPVK2Player.m_iMaxHealth', 'CBasePlayer.m_iHealth']:
        es.setplayerprop(userid, prop, int(es.getplayerprop(userid, prop))+amount)
    if time:
        dnds.getPlayer(userid)['Player'].Delayed(time, TempHealthOff, (userid,amount))
def TempHealthOff(userid, amount):
    for prop in ['CPVK2Player.m_iMaxHealth', 'CBasePlayer.m_iHealth']:
        if int(es.getplayerprop(userid, prop)) > amount:
            es.setplayerprop(userid, prop, int(es.getplayerprop(userid, prop))-amount)
        else:
            es.setplayerprop(userid, prop, 1)
def Bloodied(userid):
    if int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth')) <= int(es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth'))/2:
        return 1
    return 0
#End Global Methods
#My range() function beacuse the built in one does not work how I like
def range(start=0, stop=0, step=1):
    if not stop:
        stop = start
        start = 0
    mylist = []
    while start < stop:
        mylist.append(start)
        start += step
    return mylist
#Load and Unload Methods
def load():
    es.dbgmsg(0, '[Dungeons and Dragons] - PVKII Begin Load')
    for x in dnds.Class_List:
        for i in range(1, 6):
            dnds.Classes[x]['info'].append('pvkii %s %s'%(x, i))
        for i in range(1, 5):
            for ix in range(1, 3):
                if x != 'Ranger':
                    dnds.Classes[x]['powers%s'%ix].append('pvkii %s Powers%s %s'%(x, ix, i))
                elif x == 'Ranger':
                    dnds.Classes[x]['powers%s'%ix].append('pvkii %s Archer Powers%s %s'%(x, ix, i))
                    dnds.Classes[x]['powers%s'%ix].append('pvkii %s Two Weapon Powers%s %s'%(x, ix, i))
        if x == 'Rogue':
            dnds.Classes[x]['info'].append('pvkii %s 6'%(x))
        for y in ClassSet[x]:
            dnds.Classes[x][y] = ClassSet[x][y]
    for a in ['Strength']:
        dnds.Abilities[a]['info'].append('pvkii %s 1'%a)
    for f in ['Power Attack','Eladrin Soldier','Dwarven Weapon Training']:
        dnds.Feats[f]['info'].append('pvkii %s 1'%f)
    if not es.exists('clientcommand','+wind'):
        es.regclientcmd('+wind','dnds/games/pvkiidnds/WindOn')
    if not es.exists('clientcommand','-wind'):
        es.regclientcmd('-wind','dnds/games/pvkiidnds/WindOff')
    ServerVars = {'dnds_RoundWonXp':175}
    for x in ServerVars:
        es.ServerVar(x).set(ServerVars[x])
    for x in Commands:
        #es.msg('Found %s Command for PVKIIDNDS'%x)
        if not es.exists('clientcommand', x):
            #es.msg('Reging %s as a client command'%x)
            es.regclientcmd(x, 'dnds/games/pvkiidnds/%scmd'%x)
        #else:
            #es.msg('%s is already client command'%x)
        if not es.exists('saycommand', x):
            #es.msg('Reging %s as a Client Say command'%x)
            es.regsaycmd(x, 'dnds/games/pvkiidnds/%scmd'%x)
        #else:
            #es.msg('%s is already client say command'%x)
    es.dbgmsg(0, '[Dungeons and Dragons] - PVKII End Load')
def unload():
    es.dbgmsg(0, '[Dungeons and Dragons] - PVKII Unload Start')
    es.dbgmsg(0, '[Dungeons and Dragons] - PVKII Unload End')
Meele_Weapons = ['twosword','swordshield','archersword','cutlass','cutlass2','hook','bigaxe','axesword','twoaxe','vikingshield']
Ranged_Weapons = ['crossbow','longbow','flintlock','blunderbuss','throwaxe']
Swords = ['twosword','swordshield','archersword','cutlass','cutlass2','axesword','vikingshield']
Axes = ['bigaxe','axesword','twoaxe','throwaxe']
Special_Weapons = ['powderkeg','parrot']
Commands = ['word',
            'glow',
            'hands',
            'wolv',
            'blast',
            'missile',
            'frost',
            'burst',
            'wave',
			'guard',
            'clw',
            'unstop',
            'transpos',
            'resil',
            'bolt',
            'stride',
            'crescendo',
            'stand',
            'enfeeble',
            'acid',
            'fire',
            'ice']
default_keys = ['wind used',
                'buff',
                'stealth delay',
                'stealth key',
                'stealthed',
                'warlord aura',
                'spell cool down',
                'guard',
                'marked',
                'weakened',
                'blocking',
                'hold',
                'pa aura',
                'wl aura'
                'hold',
                'wl strike']
ClassSet = {'Cleric':   {'health':120,
                        'armor':120,
                        'model':'player/heavyknight/heavyknight',
                        'weapons': ['weapon_twoaxe','weapon_vikingshield'],
                        'ammo':{},
                        'healing surges':7,
                        'speed':1.0},
            'Fighter':  {'health':150,
                        'armor':150,
                        'model':'player/berserker/berserker',
                        'weapons':['weapon_bigaxe','weapon_crossbow','weapon_throwaxe'],
                        'ammo':{'004':10,'007':5},
                        'healing surges':9,
                        'speed':1.0},
            'Paladin':  {'health':150,
                        'armor':180,
                        'model':'player/heavyknight/heavyknight',
                        'weapons':['weapon_twosword','weapon_swordshield'],
                        'ammo':{'006':6},
                        'healing surges':10,
                        'speed':1.0},
            'Ranger':   {'health':120,
                        'armor':100,
                        'model':'player/huscarl/huscarl',
                        'weapons':['weapon_cutlass2'],
                        'ammo':{'005':30,'007':8},
                        'healing surges':6,
                        'speed':1.0},
            'Rogue':    {'health':120,
                        'armor':80,
                        'model':'player/skirmisher/skirmisher',
                        'weapons':['weapon_cutlass','weapon_flintlock'],
                        'ammo':{'003':15},
                        'healing surges':6,
                        'speed':1.0},
            'Warlock':  {'health':120,
                        'armor':80,
                        'model':'player/bowman/bowman',
                        'weapons':['weapon_cutlass','weapon_crossbow'],
                        'ammo':{'004':4},
                        'healing surges':6,
                        'speed':1.0},
            'Warlord':  {'health':120,
                        'armor':120,
                        'model':'player/berserker/berserker',
                        'weapons':['weapon_twosword','weapon_swordshield','weapon_longbow'],
                        'ammo':{'005':15},
                        'healing surges':7,
                        'speed':1.0},
            'Wizard':   {'health':100,
                        'armor':40,
                        'model':'player/captain/captain',
                        'weapons':['weapon_archersword'],
                        'ammo':{},
                        'healing surges':6,
                        'speed':1.0}}
#End Load Methods
